<?php

use yii\helpers\Html;
use yii\grid\GridView;
use common\grid\EnumColumn;
use common\models\Category;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\theme\models\search\CategorySearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('backend', 'Categories');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="category-index">

    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a(Yii::t('backend', 'Create {modelClass}', [
            'modelClass' => 'Category',
        ]), ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

//            'id',
            'name',
//            'slug',
            'description',
//            'image_url:url',
//            'image_path',
            [
                'class' => EnumColumn::className(),
                'attribute' => 'status',
                'enum' => Category::statuses(),
                'filter' => Category::statuses()
            ],
            'created_at:datetime',
//            'updated_at',

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{update}  {delete}',
                'buttons' => [
                    'download' => function ($url) {
                        return Html::a(
                            '<span class="glyphicon glyphicon-arrow-download"></span>',
                            $url,
                            [
                                'title' => 'Download',
                                'data-pjax' => '0',
                            ]
                        );
                    },
                ],
            ],
        ],
    ]); ?>

</div>
