<?php

use yii\db\Migration;

class m160903_101233_theme extends Migration
{
    // Use safeUp/safeDown to run migration code within a transaction
    public function safeUp()
    {
        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE=InnoDB';
        }

        $this->createTable('{{%theme}}', [
            'id' => $this->primaryKey(),
            'category_id' => $this->integer()->notNull(),
            'code' => $this->string(10)->notNull(),
            'slug' => $this->string(32)->notNull(),
            'name' => $this->string(32)->notNull(),
            'description' => $this->string(512),
            'status' => $this->smallInteger()->notNull(),//->defaultValue(Category::STATUS_ACTIVE),
            'created_at' => $this->integer(),
            'updated_at' => $this->integer()
        ], $tableOptions);

        $this->createTable('{{%theme_files}}', [
            'id' => $this->primaryKey(),
            'theme_code' => $this->string(10)->notNull(),
            'file_code' => $this->string(10)->notNull(),
            'created_at' => $this->integer(),
            'updated_at' => $this->integer()
        ], $tableOptions);

        $this->createIndex('idx_theme_code', '{{%theme}}', 'code');
        $this->createIndex('idx_theme_name', '{{%theme}}', 'name');
        $this->createIndex('idx_theme_slug', '{{%theme}}', 'slug');
        $this->createIndex('idx_theme_files_theme_code', '{{%theme_files}}', 'theme_code');
        $this->createIndex('idx_theme_files_file_code', '{{%theme_files}}', 'file_code');

        $this->addForeignKey('fk_theme_category', '{{%theme}}', 'category_id', '{{%category}}', 'id', 'RESTRICT',
            'RESTRICT');
        $this->addForeignKey('fk_theme_files_theme', '{{%theme_files}}', 'theme_code', '{{%theme}}', 'code', 'RESTRICT',
            'RESTRICT');
        $this->addForeignKey('fk_theme_files_category_files', '{{%theme_files}}', 'file_code', '{{%category_files}}', 'code',
            'cascade', 'cascade');
    }

    public function safeDown()
    {
        $this->dropForeignKey('fk_theme_category_files', '{{%theme_files}}');
        $this->dropForeignKey('fk_theme_files_theme', '{{%theme_files}}');
        $this->dropForeignKey('fk_theme_category', '{{%theme}}');

        $this->dropIndex('idx_theme_files_file_code', '{{%theme_files}}');
        $this->dropIndex('idx_theme_files_theme_code', '{{%theme_files}}');
        $this->dropIndex('idx_theme_slug', '{{%theme}}');
        $this->dropIndex('idx_theme_name', '{{%theme}}');
        $this->dropIndex('idx_theme_code', '{{%theme}}');

        $this->dropTable('{{%theme_files}}');
        $this->dropTable('{{%theme}}');
    }

}
